*****************************************************************
*********** hyper.s:     to read the old Junior-tapes ***********
*********** Originally written (1980) by A. Nachtmann ***********
*********** (c)1993                      Theo Driever ***********
*****************************************************************

* creation: 27-03-1993
* last mod: 03-04-1993

Gemdos      equ 1
Fcreate     equ 60
Fclose      equ 62
Fwrite      equ 64
Pterm       equ 76
Ok          equ 0
Regular     equ 0

TACR        equ $fffa19 ;Timer A Control Register
TADR        equ $fffa1f ;Timer A Data Register
GPIP        equ $fffa01 ;GPIP data register
                        ;bit-0=busy of parallel port

    clr.l   -(sp)
    move.w  #$20,-(sp)
    trap    #Gemdos 
    add     #6,sp

    movem.l a1/d0-d5,-(sp)
    move.b  TACR,d0
    move.w  d0,-(sp)

    move    sr,-(sp)
    or      #$0700,sr       

Rdtape:
    move.b  #$ff,d0 ;d0=char, reset for sync
    jsr     Msg0    ;start message
    clr.w   chk     ;clear checksum
    move.l  #file_mem,a1

Sync:
    jsr     Rdbit   ;read a bit from tape
    roxr.b  #1,d0   ;shift into character
    cmp.b   #$16,d0 ;syn character?
    bne     Sync    ;if not resync
    move.l  #10,d2  ;try it for 10 syns at least

Tensyn:
    jsr     Rdch
    cmp.b   #$16,d0 ;still syn?
    bne     Rdtape  ;if not return
    sub     #1,d2   ;10 syns received?
    bne     Tensyn  ;return while not 10 syns

Star:
    jsr     Rdch    ;wait for '*' char
    cmp.b   #'*',d0 ;start of data?
    beq     Stara
    cmp.b   #$16,d0 ;still syn?
    beq     Star    ;then wait for *
    bne     Rdtape  ;else start over

Stara:
    jsr     Rdbyt   ;read id from tape
    move.b  nibh,file_name+1
    move.b  nibl,file_name+2

Rdsa:
    jsr     Rdbyt   ;read sal from tape
    jsr     Chksum  ;checksum computation
    move.b  nibh,file_name+6
    move.b  nibl,file_name+7
    jsr     Rdbyt   ;read sah from tape
    jsr     Chksum  ;checksum computation
    move.b  nibh,file_name+4
    move.b  nibl,file_name+5

Filmem:
    jsr     Rdbyt   ;read data byte from tape
    bmi     Nothex  ;not hex? -> restart
    beq     Check   ;end of data char?
    jsr     Chksum
    move.b  d0,(a1)+ ;store byte in memory
    bra     Filmem  ;read next databyte

Nothex:
    jsr     Msg_file
    jsr     Msg1
    bra     Rdtape

Chkerror:
    jsr     Msg_file
    jsr     Msg2
    bra     Rdtape

Check:
    jsr     Rdbyt   ;read checksum from tape
    cmp.b   chkl,d0
    bne     Chkerror
    jsr     Rdbyt
    cmp.b   chkh,d0
    bne     Chkerror

    move.w  (sp)+,sr

    move    #Regular,-(sp)  ;create a file
    move.l  #file_name,-(sp)
    move    #Fcreate,-(sp)
    trap    #Gemdos
    addq.l  #8,sp
    move    d0,handle

    move.l  #file_mem,-(sp) ;write file
    suba.l  #file_mem,a1
    move.l  a1,-(sp)
    move.w  handle,-(sp)
    move.w  #Fwrite,-(sp)
    trap    #Gemdos
    add.l   #12,sp

    move    handle,(sp) ;close file
    move    #Fclose,-(sp)
    trap    #Gemdos
    add     #4,sp

    jsr     Msg_file
    jsr     Msg3

Done:
    move.w  (sp)+,d0
    move.b  d0,TACR
    movem.l (sp)+,a1/d0-d5
    move.w  #Ok,-(sp)   ;and exit
    move.w  #Pterm,-(sp)
    trap    #Gemdos

Rdbit:
    btst    #0,GPIP ;3600 Hz? (=1 from PLL)
    beq     Rdbit

    move.b  TADR,d3 ;get timerA count
    move.b  #0,TACR
    move.b  #$ff,TADR ;2400 Hz countdown
    move.b  #$0b,TACR

    move.l  #120,d1
Rdba:
    sub     #1,d1   ;delay jitter time 
    bne     Rdba

Rdbb:
    btst    #0,GPIP ;2400 Hz?
    bne     Rdbb
    move.b  TADR,d4
    move.b  #0,TACR
    move.b  #$ff,TADR ;3600 Hz countdown
    move.b  #$0b,TACR
    move.l  #70,d1

Rdbc:
    sub     #1,d1   ;delay jitter time 
    bne     Rdbc
    sub.b   d3,d4   ;set or reset carry flag
    rts

Rdbyt:
    jsr     Rdch    ;read ascii character from tape
    move.b  d0,nibh
    cmp.b   #'/',d0 ;end-of-data char?
    bne     Rbb

Rba:
    rts             ;error exit

Rbb:
    jsr     Aschex  ;ASCII to HEX conversion
    bmi     Rba     ;Not a valid hex char
    asl     #4,d0
    move.b  d0,byte ;save high order nibble
    jsr     Rdch    ;read next char
    move.b  d0,nibl
    cmp.b   #'/',d0 ;end-of-data char?
    beq     Rba
    jsr     Aschex  ;ASCII to HEX conversion
    or.b    byte,d0 ;assemble byte
    move.b  #1,byte ;z=0
    rts             ;normal exit

Aschex:
    cmp.b   #'0',d0
    bmi     Notval
    cmp.b   #':',d0 ;'9'+1
    bmi     Valid
    cmp.b   #'A',d0
    bmi     Notval
    cmp.b   #'G',d0 ;'F'+1
    bmi     Valid
Notval:
    move.b  #$ff,d1 ;set N-flag
    rts

Valid:
    cmp     #'@',d0
    bmi     Val
    add.b   #9,d0
Val:
    and.b   #$0f,d0 ;hex is lower byte now
    rts

Rdch:
    move.b  #8,d5   ;set up for 8 bits
Read:
    jsr     Rdbit   ;read a bit from tape
    roxr.b  #1,d0   ;shift bit into char
    sub     #1,d5   ;all bits received?
    bne     Read
    and.b   #$7f,d0 ;bit 7 must be zero
    rts

Chksum:
    and.w   #$ff,d0
    add.w   d0,chk        
    rts

Msg0:
    pea     msg0
    move.w  #9,-(sp)
    trap    #1
    addq.l  #6,sp
    rts
Msg1:
    pea     msg1
    move.w  #9,-(sp)
    trap    #1
    addq.l  #6,sp
    rts
Msg2:
    pea     msg2
    move.w  #9,-(sp)
    trap    #1
    addq.l  #6,sp
    rts
Msg3:
    pea     msg3
    move.w  #9,-(sp)
    trap    #1
    addq.l  #6,sp
    rts
Msg_file:
    pea     file_name
    move.w  #9,-(sp)
    trap    #1
    addq.l  #6,sp
    rts
msg0:
    dc.b    'Start',$0d,$0a,0
msg1:
    dc.b    ': Not Hex',$0d,$0a,0
msg2:
    dc.b    ': Checksum Error',$0d,$0a,0
msg3:
    dc.b    ' Written',$0d,$0a,0
file_name:
    dc.b    'Nxx_yyyy.HYP',0

    BSS
byte:
    ds.b    1
    even
nibh:
    ds.b    1
nibl:
    ds.b    1
chk:
chkh:
    ds.b    1
chkl:
    ds.b    1
handle:
    ds.w    1
file_mem:
    ds.b    16384
