*****************************************************************
*********** hyper.s:     to read the old Junior-tapes ***********
*********** Originally written (1980) by A. Nachtmann ***********
*********** (c)1993                      Theo Driever ***********
*****************************************************************

* creation: 27-03-1993
* last mod: 03-04-1993

Gemdos      equ 1
Fcreate     equ 60
Fclose      equ 62
Fwrite      equ 64
Pterm       equ 76
Ok          equ 0
Regular     equ 0

TACR        equ $fffa19 ;Timer A Control Register
TADR        equ $fffa1f ;Timer A Data Register
GPIP        equ $fffa01 ;GPIP data register
                        ;bit-0=busy of parallel port

    clr.l   -(sp)
    move.w  #$20,-(sp)
    trap    #Gemdos 
    add     #6,sp

    movem.l a1/d0-d5,-(sp)
    move.b  TACR,d0
    move.w  d0,-(sp)

    move    sr,-(sp)
    or      #$0700,sr       

Rdtape:
    move.b  #$ff,d0 ;d0=char, reset for sync
    jsr     Msg0    ;start message
    clr.w   chk     ;clear checksum
    move.l  #file_mem,a1

Sync:
    jsr     Rdbit   ;read a bit from tape
    roxr.b  #1,d0   ;shift into character
    cmp.b   #$16,d0 ;syn character?
    bne     Sync    ;if not resync
    move.l  #10,d2  ;try it for 10 syns at least

Tensyn:
    jsr     Rdch
    cmp.b   #$16,d0 ;still syn?
    bne     Rdtape  ;if not return
    sub     #1,d2   ;10 syns received?
    bne     Tensyn  ;return while not 10 syns

Star:
    jsr     Rdch    ;wait for '#' char
    cmp.b   #$23,d0 ;start of data?
    beq     Stara
    cmp.b   #$16,d0 ;still syn?
    beq     Star    ;then wait for #
    bne     Rdtape  ;else start over

Stara:
    jsr     Rdch    ;read id from tape
    jsr     Chksum  ;checksum computation
	move.b	d0,id
	jsr     Rdch	;read sal
    jsr     Chksum  ;checksum computation
	move.b	d0,sal
	jsr     Rdch	;read sah
    jsr     Chksum  ;checksum computation
	move.b	d0,sah
	jsr     Rdch	;read eal
    jsr     Chksum  ;checksum computation
	move.b	d0,eal
	jsr     Rdch	;read eah
    jsr     Chksum  ;checksum computation
	move.b	d0,eah

	jsr		Rdch	;read checksum
	cmp.b	chkl,d0
	beq		Checkchkh
	jsr		Msg1
Checkchkh:
	jsr		Rdch	;read checksum
	cmp.b	chkh,d0
	beq		Checkeot
	jsr		Msg1

Checkeot:
    clr.w   chk     ;clear checksum
	jsr		Rdch	;EOT (header)
	cmp.b	#04,d0
	bne		Eot1error

	move.w	ea,d2
	sub.w	sa,d2

Resync:
	jsr		Rdch
    cmp.b   #$16,d0 ;syn?
    beq     Resync  ;then wait for #
	cmp.b	#$23,d0	;#?
	beq		Filmem	;start reading file!

    jsr     Msg5
	bra		Rdtape

Eot1error:
    jsr     Msg2
	bra		Rdtape

Chk2error:
    jsr     Msg3
	bra		Rdtape

Eot2error:
    jsr     Msg4
	bra		Rdtape

Filmem:
	jsr 	Rdch	;read data from tape
    jsr     Chksum  ;checksum computation
	move.b	d0,(a1)+
	sub.w	#1,d2
	bne		Filmem

	jsr		Rdch	;read checksum
	cmp.b	chkl,d0
	bne		Chk2error
	jsr		Rdch	;read checksum
	cmp.b	chkh,d0
	bne		Chk2error

	jsr		Rdch	;EOT (header)
	cmp		#04,d0
	bne		Eot2error

	move.b	id,d0
	jsr		Nibh
	move.b	d0,file_name+1
	move.b	id,d0
	jsr		Nibl
	move.b	d0,file_name+2

	move.b	sah,d0
	jsr		Nibh
	move.b	d0,file_name+4
	move.b	sah,d0
	jsr		Nibl
	move.b	d0,file_name+5

	move.b	sal,d0
	jsr		Nibh
	move.b	d0,file_name+6
	move.b	sal,d0
	jsr		Nibl
	move.b	d0,file_name+7

    move.w  (sp)+,sr

    move    #Regular,-(sp)  ;create a file
    move.l  #file_name,-(sp)
    move    #Fcreate,-(sp)
    trap    #Gemdos
    addq.l  #8,sp
    move    d0,handle

    move.l  #file_mem,-(sp) ;write file
    suba.l  #file_mem,a1
    move.l  a1,-(sp)
    move.w  handle,-(sp)
    move.w  #Fwrite,-(sp)
    trap    #Gemdos
    add.l   #12,sp

    move    handle,(sp) ;close file
    move    #Fclose,-(sp)
    trap    #Gemdos
    add     #4,sp

    jsr     Msg_file
    jsr     Msg6

Done:
    move.w  (sp)+,d0
    move.b  d0,TACR
    movem.l (sp)+,a1/d0-d5
    move.w  #Ok,-(sp)   ;and exit
    move.w  #Pterm,-(sp)
    trap    #Gemdos

Rdbit:
    btst    #0,GPIP ;3600 Hz? (=1 from PLL)
    beq     Rdbit

    move.b  TADR,d3 ;get timerA count
    move.b  #0,TACR
    move.b  #$ff,TADR ;2400 Hz countdown
    move.b  #$0b,TACR

    move.l  #120,d1
Rdba:
    sub     #1,d1   ;delay jitter time 
    bne     Rdba

Rdbb:
    btst    #0,GPIP ;2400 Hz?
    bne     Rdbb
    move.b  TADR,d4
    move.b  #0,TACR
    move.b  #$ff,TADR ;3600 Hz countdown
    move.b  #$0b,TACR
    move.l  #70,d1

Rdbc:
    sub     #1,d1   ;delay jitter time 
    bne     Rdbc
    sub.b   d3,d4   ;set or reset carry flag
    rts

Rdch:
    move.b  #8,d5   ;set up for 8 bits
Read:
    jsr     Rdbit   ;read a bit from tape
    roxr.b  #1,d0   ;shift bit into char
    sub     #1,d5   ;all bits received?
    bne     Read
    and.b   #$ff,d0
    rts

Chksum:
    and.w   #$ff,d0
    add.w   d0,chk        
    rts

Nibh:
	and.b	#$f0,d0
	ror.b	#4,d0
Nibl:
	and.b	#$0f,d0
	cmp		#10,d0
	bmi		Numval
	add.b	#$37,d0
	rts
Numval:
	add.b	#$30,d0
	rts

Msg0:
    pea     msg0
    move.w  #9,-(sp)
    trap    #1
    addq.l  #6,sp
    rts
Msg1:
    pea     msg1
    move.w  #9,-(sp)
    trap    #1
    addq.l  #6,sp
    rts
Msg2:
    pea     msg2
    move.w  #9,-(sp)
    trap    #1
    addq.l  #6,sp
    rts
Msg3:
    pea     msg3
    move.w  #9,-(sp)
    trap    #1
    addq.l  #6,sp
    rts
Msg4:
    pea     msg4
    move.w  #9,-(sp)
    trap    #1
    addq.l  #6,sp
    rts
Msg5:
    pea     msg5
    move.w  #9,-(sp)
    trap    #1
    addq.l  #6,sp
    rts
Msg6:
    pea     msg6
    move.w  #9,-(sp)
    trap    #1
    addq.l  #6,sp
    rts
Msg_file:
    pea     file_name
    move.w  #9,-(sp)
    trap    #1
    addq.l  #6,sp
    rts
msg0:
    dc.b    'Start',$0d,$0a,0
msg1:
    dc.b    'Checksum error (header)',$0d,$0a,0
msg2:
    dc.b    'not EOT char (header)',$0d,$0a,0
msg3:
    dc.b    'Checksum error (data)',$0d,$0a,0
msg4:
    dc.b    'not EOT char (data)',$0d,$0a,0
msg5:
    dc.b    'Resync error',$0d,$0a,0
msg6:
    dc.b    ' Written',$0d,$0a,0
file_name:
    dc.b    'Mxx_yyyy.HYP',0

    BSS
id:
	ds.b	1
    even
sa:
sah:
    ds.b    1
sal:
    ds.b    1
ea:
eah:
    ds.b    1
eal:
    ds.b    1
chk:
chkh:
    ds.b    1
chkl:
    ds.b    1
handle:
    ds.w    1
file_mem:
    ds.b    16384
