*****************************************************************
*********** hyper.s:     to read the old Junior-tapes ***********
*********** Originally written (1980) by A. Nachtmann ***********
*********** (c)1993                      Theo Driever ***********
*****************************************************************

* creation: 27-03-1993
* last mod: 30-03-1993

Gemdos      equ 1
Fcreate     equ 60
Fclose      equ 62
Fwrite      equ 64
Pterm       equ 76
Ok          equ 0
Regular     equ 0

TACR        equ $fffa19 ;Timer A Control Register
TADR        equ $fffa1f ;Timer A Data Register
GPIP        equ $fffa01 ;GPIP data register
                        ;bit-0=busy of parallel port

    clr.l   -(sp)
    move.w  #$20,-(sp)
    trap    #Gemdos 
    add     #6,sp

    movem.l a1/d0-d5,-(sp)
    move.b  TACR,d0
    move.w  d0,-(sp)
    move    sr,-(sp)
    or      #$0700,sr       
Rdtape:
    move.l  #file_mem,a1
    move.l  #5000,d0 

Synn:
    jsr     Rdbit   ;read a bit from tape
    bcs     One
    move.b  #0,(a1)+
    bra     Bitfound
One:
    move.b  #1,(a1)+
Bitfound:
    sub     #1,d0
    bne     Synn

    move.w  (sp)+,sr

    move    #Regular,-(sp)  ;create a file
    move.l  #file_name,-(sp)
    move    #Fcreate,-(sp)
    trap    #Gemdos
    addq.l  #8,sp
    move    d0,handle

    move.l  #file_mem,-(sp) ;write file
    move.l  #5000,-(sp)
    move.w  handle,-(sp)
    move.w  #Fwrite,-(sp)
    trap    #Gemdos
    add.l   #12,sp

    move    handle,(sp) ;close file
    move    #Fclose,-(sp)
    trap    #Gemdos
    add     #4,sp

Done:
    move.w  (sp)+,d0
    move.b  d0,TACR
    movem.l (sp)+,a1/d0-d5
    move.w  #Ok,-(sp)   ;and exit
    move.w  #Pterm,-(sp)
    trap    #Gemdos

Rdbit:
    btst    #0,GPIP ;3600 Hz? (=1 from PLL)
    beq     Rdbit

    move.b  TADR,d3 ;get timerA count
    move.b  #0,TACR
    move.b  #$ff,TADR ;2400 Hz countdown
    move.b  #$0b,TACR

    move.l  #120,d1
Rdba:
    sub     #1,d1   ;delay jitter time 
    bne     Rdba

Rdbb:
    btst    #0,GPIP ;2400 Hz?
    bne     Rdbb
    move.b  TADR,d4
    move.b  #0,TACR
    move.b  #$ff,TADR ;3600 Hz countdown
    move.b  #$0b,TACR
    move.l  #120,d1

Rdbc:
    sub     #1,d1   ;delay jitter time 
    bne     Rdbc
    sub.b   d3,d4   ;set or reset carry flag
    rts


file_name:
    dc.b    'test.hyp',0

    BSS
    even
handle:
    ds.w    1
file_mem:
    ds.b    16384
